import java.io.*;
//import gom.*;
//import gom.std.*;

/**
* 	GettingStarted
*	@author		M. Delalandre
*	@version	05/2005
*/
public class GettingStarted {

	/**
 	This library is based on a generic (and abstract) OGraphic object use.
 	From this object, the GOMLib can be easily extended with new object types
 	The GOMLib proposes too implementations of standard graphics objects
 	(OPoint, OLine, OArc, OCurve, and so on).
 	The following method gives an example of objects create.
	*/
	public static void init1() {
		OGraphic o1,o2;
		o1 = new OPoint(1,1);
		o1.print();
		o2 = new OLine(1,1,8,8);
		o2.print();
		}

	/**
 	However, you can use the standard object types in your programs.
 	*/
	public static void init2() {
		OPoint p = new OPoint(1,1);
		p.print();
		OLine l = new OLine(1,1,8,8);
		l.print();
		}

	/**
 	Java language use reference, you can use
 	the copy method to solve this problem.
 	*/
	public static void init3() {
		OPoint p1 = new OPoint(1,1);
		OPoint p2 = p1; /* here p1 and p2 are the same object */
		//OPoint p3 = p1.copy(); /* here p1 and p3 are different */
		}


	/**
 	The GOMLib represents the graphical knowledge through
 	the Graphics Object Modelling Language "GOML".
 	The GOML files are extended with ".gom".
 	Use the different "gom" methods of Read and Write classes
 	to read/write the "gom" files.
 	You can export too in XML and SVG formats with the methods xmlWrite() and svgWrite().
 	The following method gives a simple example of arc write and read:
 	*/
	public static void write() {
		OGraphic p;
		OPoint pt1,pt2;
		pt1 = new OPoint(50,50);
		pt2 = new OPoint (150,50);

		p = new OLine(pt1,pt2);
		Write.gomWrite(p,"test.gom");
		Write.xmlWrite(p,"test.xml");
		Write.svgWrite(p,"test.svg");
		p = Read.gomRead("test.gom");
		p.print();
		}

	/**
 	The read method imports a OGraphic*,
 	in order to access standard objects' methods, you must:
 		to know the object type
 		to cast the OGraphic type

	Use instanceof and cast methodnality.
	The following method gives an example of type test and dynamic cast use.
 	*/
	public static void read() {
    	OGraphic p;
		OPoint pt1,pt2;
		pt1 = new OPoint(50,50);
		pt2 = new OPoint (150,50);
		p = new OLine(pt1,pt2);

		Write.gomWrite(p,"test.gom");
		p = Read.gomRead("test.gom");

    	if(p instanceof OLine) {
			OLine l = (OLine)p;
			System.out.println(l.getLength());
			}
		}

		public static void ohl1() {

			OHL my = new OHL();
			my.addObj(new OLine(10,40,50,40));
			my.addObj(new OLine(80,40,80,40));
			Write.gomWrite(my,"text.gom");
			//OGraph o =new OGraph(true);
			//OGraphic o = Read.gomRead("res3.gom");
		}

	/** main */
	public static void main(String args[]) throws Exception {
		//init1();
		//init2();
		//init3();
		//write();
		//read();
		ohl1();
		}
	}