import java.io.*;

/**
* 	OGraphic interface is the basic class used
*	to define a OGraphic object.
*	See <a href="OGraphicImpl.html">OGraphicImpl<a/> for
*	a standard implementation of this interface.
*	@author		M. Delalandre, K. Zouba
*	@version	05/2005
*	@see		OGraphicImpl
*/
public interface OGraphic {

	/** Copy the OGraphic object */
	public abstract OGraphic copy();

	/** Define how write a OGraphic object into a gom file */
	public abstract void gomWrite(BufferedWriter flow);

	/** Define how write a OGraphic object into a xml file */
	public abstract void xmlWrite(BufferedWriter flow);

	/** Define how write a OGraphic object into a svg file */
	public abstract void svgWrite(BufferedWriter flow);

	/** Define how read a OGraphic object into a gom file */
	public abstract void gomRead(BufferedReader flow);
	/**xgmmlWrite*/
	public abstract void xgmmlWrite (BufferedWriter flow);

	/** Used to obtain the complet class name */
	public abstract String getName();

	/** Used to print OGraphic object properties */
	public abstract void print();
	}
