import java.io.*;
import java.util.*;

/**
*   OHL
*	@author		M. Delalandre, R. Norolala
*	@version	05/2005
*/
public class OHL extends OGraphicImpl  {
	Vector ov, av;
	int i;

	/** Default constructor */
	public OHL() {ov = new Vector(); av = new Vector();}

	public OGraphic copy() {OHL o =new OHL(); o.ov=(Vector)ov.clone(); return o;}

	/** Clear the object and attribute vector */
	public void clear() {ov.clear();av.clear();}

	/** Clear the object vector */
	public void objClear() {ov.clear();}

	/** Clear the attribute vector */
	public void attClear() {av.clear();}

	/** Return the vector size of graphic object */
	public int objSize() {return ov.size();}

	/** Add a graphic object */
	public void addObj(OGraphic o) {ov.add((Object)o);}

	/** Add a graphic object */
	public void addObj(int i,OGraphic o) {ov.add(i,(Object)o);}

	/** Remove a graphic object */
	public void removeObj(int i) {ov.remove(i);}

	/** Get a graphic object */
	public OGraphic getObj(int i) {return (OGraphic)ov.get(i);}

	/** Set a graphic object */
	public void setObj(int i,OGraphic o) {ov.set(i,(Object)o);}

	/** get a graphic object's range */
	public int objRange(OGraphic o) {
		for(i=0;i<ov.size();i++) if(ov.get(i)==o) return i;
		return -1;
		}
	/** return true if OHL is composed
     *  of same given object name
	**/
	public boolean sameObject(OGraphic o) {
		return ov.contains((Object) o);
	}
	/** return true if OHL is composed
	* of same given OHL
	**/
	public boolean sameSet(OHL o) {
		return ov.containsAll(o.ov);
	}

	public OHL clone_OHL() {

			OHL o= new OHL();
			o.ov=(Vector)(ov.clone());
			return o;

	}

	/** gomRead */
	public void gomRead(BufferedReader flow)  {
		int size; OGraphic o;
		try {
			clear();

			size = Integer.parseInt(flow.readLine());
			for(i=0;i<size;i++) {
				o = Read.load(flow.readLine());
				o.gomRead(flow);
				ov.add((Object)o);
				}

			size = Integer.parseInt(flow.readLine());
			for(i=0;i<size;i++) {
				o = Read.load(flow.readLine());
				o.gomRead(flow);
				av.add((Object)o);
				}
			}
		catch(IOException e) {System.out.println("IOException");}
		}

	/** gomWrite */
	public void gomWrite(BufferedWriter flow) {
		try {
			flow.write(getName()+"\n");

			flow.write(ov.size()+"\n");
			for(i=0; i<ov.size(); i++)
				((OGraphic)ov.get(i)).gomWrite(flow);

			flow.write(av.size()+"\n");
			for(i=0; i<av.size(); i++)
				((OGraphic)av.get(i)).gomWrite(flow);
			}
		catch(IOException e) {System.out.println("IOException");}
		}

	/** xmlWrite */
	public void xmlWrite(BufferedWriter flow) {
		try {
			flow.write("<"+getName()+">\n");

			flow.write("<ov size=\""+ ov.size()+"\">\n");
			for(i=0; i<ov.size(); i++) {
				flow.write("<o id=\""+ i +"\">\n");
				((OGraphic)ov.get(i)).xmlWrite(flow);
				flow.write("</o>\n");
				}
			flow.write("</ov>");

			flow.write("<av size=\""+ av.size()+"\">\n");
			for(i=0; i<av.size(); i++) {
				flow.write("<a id=\""+ i +"\">\n");
				((OGraphic)av.get(i)).xmlWrite(flow);
				flow.write("</a>\n");
				}
			flow.write("</av>");

			flow.write("</"+getName()+">");
			}
		catch(IOException e) {System.out.println("IOException");}
		}

	/** svgWrite */
	public void svgWrite(BufferedWriter flow) {
		for(i=0; i<ov.size(); i++)
			((OGraphic)ov.get(i)).svgWrite(flow);
		for(i=0; i<av.size(); i++)
			((OGraphic)av.get(i)).svgWrite(flow);
		}
	/** xgmmlWrite*/
	public void xgmmlWrite (BufferedWriter flow) {}
	}

