//package gom;

import java.io.*;
import java.util.*;

import org._3pq.jgrapht.graph.*;
import org._3pq.jgrapht.edge.*;
import org._3pq.jgrapht.*;


public class ORaig extends DirectedMultigraph implements OGraphic {

	HashMap eMap; /*= new HashMap();*/
	private boolean d;

    public ORaig() {
        super();
		eMap = new HashMap(); this.d = false;
    	}

    public ORaig(boolean d) {
        super();
		eMap = new HashMap(); this.d = d;
    	}

	public Edge addEdge(OGraphic sourceVertex, OGraphic targetVertex, OGraphic o) {
		Edge e = addEdge((Object)sourceVertex,(Object)targetVertex);
		eMap.put(e,o);
		return e;
		}

	public Edge addEdge(OGraphic sourceVertex, OGraphic targetVertex,String o) {
			Edge e = addEdge((Object)sourceVertex,(Object)targetVertex);
			eMap.put(e,o);
			return e;
			}



	public boolean addVertex(OGraphic o) {
		return addVertex((Object)o);
		}

	public OGraphic vertexRead(int p) {
		Object [] oArray = vertexSet().toArray();
		if(p>oArray.length)
			return null;
		else
			return (OGraphic)oArray[p];
		}

	public int rangeRead (OGraphic o) {
		Object [] oArray = vertexSet().toArray();
		if(oArray.length == 0)
			return -1;
		else
			for(int i=0;i<oArray.length;i++) {
				if(oArray[i] == o)
					return i;
				}
		return -1;
		}

	public int number_of_nodes () {
		return vertexSet().size();
		}

	public int number_of_edges() {
		return edgeSet().size();
		}

	public boolean is_directed() {
		return this.d;
		}

	public int degree_of_Vertex (OGraphic o) {
		return edgesOf((Object)(o)).size();
		}


	public void gomWrite(BufferedWriter flow){
		try {
			flow.write(getName()+"\n");
			flow.write(number_of_nodes()+"\n");

			Iterator vi = vertexSet().iterator();
			while (vi.hasNext())
				((OGraphic)vi.next()).gomWrite(flow);

			flow.write(number_of_edges()+"\n");
			Iterator ei = edgeSet().iterator(); Edge e; OGraphic o1,o2,o;String s;
			while(ei.hasNext()) {
				e = (Edge)ei.next();

				o1=(OGraphic)(e.getSource()); o2=(OGraphic)(e.getTarget());
				flow.write(rangeRead(o1)+" "+rangeRead(o2)+"\n");

				s = (String)eMap.get(e);
				if(s.equals("adjacency")) flow.write("adjacency"+"\n");
				if(s.equals("include")) flow.write("include"+"\n");
				if (s.equals("empty")) flow.write("empty"+"\n");
				}
			}
		catch(IOException e)
			{System.out.println("IOException");}
		}


	public void xmlWrite(BufferedWriter flow){
		Iterator vi = vertexSet().iterator();
		while (vi.hasNext())
			((OGraphic)vi.next()).xmlWrite(flow);
		}

	public void svgWrite(BufferedWriter flow){
		Iterator vi = vertexSet().iterator();
		while (vi.hasNext())
			((OGraphic)vi.next()).svgWrite(flow);
		}

	public  void gomRead(BufferedReader flow){
		int size, i, v1, v2; OGraphic o;
		StringTokenizer tok; String oEdge;
		try {
			this.d = Boolean.getBoolean(flow.readLine());

			size = Integer.parseInt(flow.readLine());
			for (i=0;i<size;i++) {
				o = Read.load(flow.readLine());
				o.gomRead(flow);
				addVertex(o);
				}

			size = Integer.parseInt(flow.readLine());
			for (i=0;i<size;i++) {
				tok = new StringTokenizer (flow.readLine()," ");
				v1 = Integer.parseInt(tok.nextToken());
				v2 = Integer.parseInt(tok.nextToken());

				oEdge = flow.readLine();
				if(oEdge.equals("empty"))
					addEdge(vertexRead(v1),vertexRead(v2));
				else {
					o = Read.load(oEdge);
					o.gomRead(flow);
					addEdge(vertexRead(v1),vertexRead(v2),o);
					}
				}
			}
		catch(IOException e)
			{System.out.println("IOException");}
		}

	/**xgmmlWrite*/
	public void xgmmlWrite (BufferedWriter flow) {

		try {
		Object [] Vtx=vertexSet().toArray();
		for (int i=0;i<Vtx.length;i++)
		flow.write("<node id=\""+i+"\" label=\"Region\"/>\n");
		Iterator ei = edgeSet().iterator(); Edge e; OGraphic o1,o2;String s;
		while(ei.hasNext()) {
		e = (Edge)ei.next();
		o1=(OGraphic)(e.getSource()); o2=(OGraphic)(e.getTarget());
		int src=rangeRead(o1);
		int trg=rangeRead(o2);
		s = (String)eMap.get(e);
		if(s.equals("adjacency")){
		flow.write("<edge label=\"adjacency\" source=\""+src+"\" target=\""+trg+"\"/>\n");
		flow.write("<edge label=\"adjacency\" source=\""+trg+"\" target=\""+src+"\"/>\n");
		}
		if(s.equals("include"))
		flow.write("<edge label=\"include\" source=\""+src+"\" target=\""+trg+"\"/>\n");
		}
		}
		catch(IOException e)
			{System.out.println("IOException");}
		}

	public void print() {}
	public String getName() {return getClass().getName();}
	public OGraphic copy(){return null;}
	public int degree(Object vertex) {
			return inDegreeOf(vertex)+outDegreeOf(vertex);

	}
	}
