import java.io.*;
import java.util.*;

/**
*   OHL
*	@author		K.ZOUBA
*	@version	06/2005
*/
public class ORegion extends OGraphicImpl  {

private OHL region=new OHL();
private double ymax,ymin,xmax,xmin;
public ORegion () {
ymax=0;
ymin=0;
xmax=0;
xmin=0;
}
public void setRegion(OHL L) {
	region=L;
}
public OHL getRegion() {
	return region;
}
public String getName() {return getClass().getName();}
public void print() {}

	/** gomRead */
	public void gomRead(BufferedReader flow)  {
		region.gomRead(flow);
		}
	/** SvgWrite*/
	public void svgWrite(BufferedWriter flow) {

		int x,y;
		try {
				flow.write("<polygon points=\"");
				OHL cycle=(OHL)(region);
				cycle=sort(cycle);
				OHL List= new OHL();
				for(int i=0;i<cycle.objSize();i++) {

					     OPoint begin=((OLine)(cycle.getObj(i))).getBegin();
			   			 OPoint end=((OLine)(cycle.getObj(i))).getEnd();
					     if(!(Present(List,begin))) List.addObj(begin);
					     if(!(Present(List,end))) List.addObj(end);
					}
				for(int j=0;j<List.objSize()-1;j++)	{

						flow.write(""+((OPoint)(List.getObj(j))).getX()+",");
						flow.write(""+((OPoint)(List.getObj(j))).getY()+",");
					}
						flow.write(""+((OPoint)(List.getObj(List.objSize()-1))).getX()+",");
						flow.write(""+((OPoint)(List.getObj(List.objSize()-1))).getY()+"\" ");
						flow.write("style=\"fill:none; stroke:black; stroke-width:2\"/>\n");
			}

		catch(IOException e) {System.out.println("IOException");}

	}
	/** xmlWrite */
	public void xmlWrite(BufferedWriter flow) {region.xmlWrite(flow);}

	/**xgmmlWrite*/
	public void xgmmlWrite (BufferedWriter flow) {}

	/**gomWrite*/
	public void gomWrite(BufferedWriter flow) {
	try {
			flow.write(getName()+"\n");
			flow.write(region.objSize()+"\n");
			for(int i=0; i<(region.ov).size(); i++)
			((OGraphic)(region.ov).get(i)).gomWrite(flow);
			flow.write((region.av).size()+"\n");
			for(int i=0; i<(region.av).size(); i++)
			((OGraphic)(region.av).get(i)).gomWrite(flow);
		}

	catch(IOException e) {System.out.println("IOException");}
	}

	/** copy */
	public OGraphic copy() {ORegion o =new ORegion(); return o;}

	/** isAdjacente
	** Checking if a region is adjacente to another region
	**/
	public boolean isAdjacente(ORegion R2) {

		OHL cycle1=(OHL)(this.region);
		OHL cycle2=(OHL)(R2.region);
		OHL adjacency =new OHL();
		for(int l=0;l<cycle2.objSize();l++)	{

				if((cycle1.sameObject(((OLine)cycle2.getObj(l))))&&(!adjacency.sameObject(((OLine)cycle2.getObj(l)))))
				adjacency.addObj(cycle2.getObj(l));
			}
		if(adjacency.objSize()>0) return true; return false;
	}

	/** isInclude
	** Checking if a region is included into another region
	**/
	public boolean isInclude(ORegion R2) {

		this.min_max();
		R2.min_max();
		if(((R2.xmin<this.xmin)&&(R2.xmax>this.xmax))&&((R2.ymin<this.ymin)&&(R2.ymax>this.ymax)))
		return true;
		return false;
	}

	/** Method min_max */

	public void min_max() {

		OHL cycle=(OHL)(this.region);
		OPoint P1= new OPoint();
		OPoint P2= new OPoint();
		OLine L=(OLine)(cycle.getObj(0));
		P1= L.getBegin();
		P2=L.getEnd();
		this.xmin=P1.getX();this.xmax=P1.getX();this.ymin=P1.getY();this.ymax=P1.getY();
		if(P2.getX()>this.xmax) this.xmax=P2.getX();
		if(P2.getX()<this.xmin) this.xmin=P2.getX();
		if(P2.getY()>this.ymax) this.ymax=P2.getY();
		if(P2.getY()<this.ymin) this.ymin=P2.getY();
		for (int i=1;i<cycle.objSize();i++)	{

			L=(OLine)(cycle.getObj(i));
			P1= L.getBegin();
			P2=L.getEnd();
			if(P2.getX()>this.xmax) this.xmax=P2.getX();
			if(P2.getX()<this.xmin) this.xmin=P2.getX();
			if(P2.getY()>this.ymax) this.ymax=P2.getY();
			if(P2.getY()<this.ymin) this.ymin=P2.getY();
			if(P1.getX()>this.xmax) this.xmax=P1.getX();
			if(P1.getX()<this.xmin) this.xmin=P1.getX();
			if(P1.getY()>this.ymax) this.ymax=P1.getY();
			if(P1.getY()<this.ymin) this.ymin=P1.getY();
		}
	}

	/**
	** return true if a OPoint object is already present
	** into a OHL object
	**/

	public static boolean Present(OHL o, OPoint ext) {
			for(int i=0;i<o.objSize();i++)
			if(ext.equals((OPoint)(o.getObj(i))))
			return true;
			return false;
	}

	/** This method computes the centre of gravity
	** of a region
	**/
	public OPoint gravity(ORegion R) {

		OHL cycle=(OHL)(R.region);
		OHL List= new OHL();
		double xc=0;
		double yc=0;
		for(int i=0;i<cycle.objSize();i++)
		{
			OPoint begin=((OLine)(cycle.getObj(i))).getBegin();
			OPoint end=((OLine)(cycle.getObj(i))).getEnd();
			if(!(Present(List,begin))) List.addObj(begin);
			if(!(Present(List,end))) List.addObj(end);
		}
		for(int j=0;j<List.objSize();j++)
		{
			xc+=((OPoint)(List.getObj(j))).getX();
			yc+=((OPoint)(List.getObj(j))).getY();
		}
		xc=((xc/List.objSize()));
		yc=((yc/List.objSize()));
		OPoint cg=new OPoint((int)xc,(int)yc);
		return cg;
	}

	/** Method "sort" */

	public static OHL sort(OHL cycle) {

		OHL List= new OHL();
		OLine last= new OLine();
		OLine L=new OLine();
		List.addObj((OLine)(cycle.getObj(0)));
		last=(OLine)(cycle.getObj(0));
		for(int i=1;i<cycle.objSize();i++)
		{
			L=(OLine)(cycle.getObj(i));
			if(L.getEnd().equals(last.getBegin())) {List.setObj(i-1,last.getReverse());List.addObj(L.getReverse());}
			if(L.getBegin().equals(last.getBegin())){List.setObj(i-1,last.getReverse());List.addObj(L);}
			if(L.getEnd().equals(last.getEnd())) List.addObj(L.getReverse());
			if(L.getBegin().equals(last.getEnd())) List.addObj(L);
			last=L;
		}
		return List;
	}
}









