//package gom;

import java.io.*;
import java.net.*;
import java.util.*;

/**
*   This class contains a static method to read the gom file.
*	@author		M. Delalandre, K. Zouba
*	@version	05/2005
*/
public class Read {

	private static ClassLoader loader = new URLClassLoader(urlCreate());

	private static URL[] urlCreate() {
		URL[] urlT = new URL[1];
		try
			{urlT[0] = new URL("file://");}
		catch(MalformedURLException e) {}
		return urlT;
		}

	/**
	* Use this static method for the dynamic load of graphic object
	*	<pre>
	*		OGraphic p = Read.load("OPoint");
	*	</pre>
	*/
	static public OGraphic load(String gName)	{
		Object o = null;
		try
			{
			o = loader.loadClass(gName).newInstance();
			}
		catch(ClassNotFoundException e)
				{System.out.println("ClassNotFoundException: "+gName);}
		catch(InstantiationException e)
				{System.out.println("InstantiationException: "+gName);}
		catch(IllegalAccessException e)
			{System.out.println("IllegalAccessException: "+gName);}
		return (OGraphic)o;
		}

	/**
	* Use this static method to read the gom files
	*	<pre>
	*		OGraphic p = Read.gomRead("test.gom");
	*	</pre>
	*/
	public static OGraphic gomRead(String fName) {
	    OGraphic g = null;
		try {
			BufferedReader flow = new BufferedReader (new FileReader(fName)) ;
			String gName = flow.readLine();
			if(gName != null) {
				try {
					g = load(gName);
					if(g != null)
					System.out.println("ca passe !!!");
						g.gomRead(flow);
					}
				catch(NumberFormatException e)
					{System.out.println("NumberFormatException: "+gName);}
				}
			else
				System.out.println("NullGOMStartException: "+fName);
			flow.close();
			}
		catch(IOException e) {
			System.out.println("IOException: "+fName);
			}
		return g;
		}

	}

