import java.io.*;
import java.util.*;

/**
*   This class contains some static methods to write the gom, xml, and svg files.
*	@author		K. Zouba, M. Delalandre
*	@version	05/2005
*/
public class Write {
	private static BufferedWriter flow;

	/**
	* Use this static method to write the gom files
	*	<pre>
	*		OGraphic p = Write.gomWrite("test.gom");
	*	</pre>
	*/
	static public void gomWrite(OGraphic g, String wName) {
		try {
			flow = new BufferedWriter (new FileWriter (wName));
			g.gomWrite(flow);
			flow.close();
			}
		catch(IOException e) {System.out.println("IOException");}
		}

	/**
	* Use this static method to write the xml files
	*	<pre>
	*		OGraphic p = Write.xmlWrite("test.xml");
	*	</pre>
	*/
	static public void xmlWrite (OGraphic g, String wName) {
		try {
			flow = new BufferedWriter (new FileWriter (wName));
			flow.write("<?xml version=\""+1.0+"\"?>"+"\n");
			g.xmlWrite(flow);
			flow.close();
			}
		catch(IOException e) {System.out.println("IOException");}
		}

	/**
	* Use this static method to write the svg files
	*	<pre>
	*		OGraphic p = Write.svgWrite("test.svg");
	*	</pre>
	*/
	static public void svgWrite (OGraphic g ,String wName) {
		try {
			flow = new BufferedWriter (new FileWriter (wName));
			flow.write("<?xml version=\""+1.0+"\"?>"+"\n");
			flow.write("<svg>\n");
			System.out.println("g="+g);
			g.svgWrite(flow);
			flow.write("</svg>\n");
			flow.close();
			}
		catch(IOException e) {System.out.println("IOException");}
		}

	/**
		* Use this static method to write the xgmml files
		*	<pre>
		*		OGraphic p = Write.svgWrite("test.svg");
		*	</pre>
		*/
		static public void xgmmlWrite (OGraphic g ,String wName) {
			try {
				flow = new BufferedWriter (new FileWriter (wName));
				flow.write("<?xml version=\""+1.0+"\"?>"+"\n");
				flow.write("<graph directed=\""+1+"\">"+"\n");
				g.xgmmlWrite(flow);
				flow.write("</graph>\n");
				flow.close();
				}
			catch(IOException e) {System.out.println("IOException");}
		}

	}

